#import "ApduController.h"
#import <stdio.h>
#import <winscard.h>
#import <debuglog.h>

@implementation ApduController

void ShowError(long id) {
 NSString *ns;
 char *pcscerror;
    pcscerror = strdup( pcsc_stringify_error(id) );
    ns = [NSString stringWithCString:pcscerror];	
    NSRunAlertPanel(@"Error...", ns, @"OK", NULL, NULL);
    free (pcscerror);
}

- (void)transmitClick:(id)sender
{

    NSString *txNSApduValue, *rxNSApduValue;
    
    /* PC/SC Types */

    LONG rv;
    DWORD rxLength;
    SCARDCONTEXT hContext;
    SCARDHANDLE hCard;
    UCHAR rxUCBuffer[MAX_BUFFER_SIZE];
    UCHAR txUCBuffer[MAX_BUFFER_SIZE];
    struct ReaderContext *rContext;
    SCARD_IO_REQUEST sSendPci, sRecvPci;
    SCARD_READERSTATE_A rgReaderStates;
    DWORD dwReaderLen, dwState, dwProt, dwAtrLen;
    DWORD dwSendLength, dwRecvLength, dwPref, dwReaders;
    LPSTR pcReaders, mszReaders;
    BYTE pbAtr[MAX_ATR_SIZE];
    LPCSTR mszGroups;
  
    char *txApduValue, rxApduValue[700];
    int i, j;
    
    
    rv = SCardEstablishContext( SCARD_SCOPE_SYSTEM, NULL, NULL, &hContext );

    if ( rv != SCARD_S_SUCCESS ) {
        ShowError( rv );
        return 1;
    }

    mszGroups = 0;
    rv = SCardListReaders( hContext, mszGroups, 0, &dwReaders );
    if ( rv != SCARD_S_SUCCESS ) {
        ShowError( rv );
        return 1;
    }

    mszReaders = (char *)malloc(sizeof(char)*dwReaders);
    rv = SCardListReaders( hContext, mszGroups, mszReaders, &dwReaders );
    if ( rv != SCARD_S_SUCCESS ) {
        ShowError( rv );
        return 1;
    }


    rv = SCardConnect(hContext, mszReaders, 
                        SCARD_SHARE_SHARED, SCARD_PROTOCOL_T0, 
                        &hCard, &dwPref);
    if ( rv != SCARD_S_SUCCESS ) {
        ShowError( rv );
        return 1;
    }

    
    txNSApduValue = [txTextField stringValue];
    txApduValue = [txNSApduValue cString];

    j=0;
    
    for (i=0; i < strlen(txApduValue); i+=2) {
    
        if ( txApduValue[i] == ' ' ) { i+= 1; }
        if ( txApduValue[i] >= '0' && txApduValue[i] <= '9' ) {
            txUCBuffer[j] = 0x10 * (txApduValue[i] - '0');
        } else if ( txApduValue[i] >= 'A' && txApduValue[i] <= 'F' ) {
            txUCBuffer[j] = 0x10 * ((txApduValue[i] - 'A')+10);
        } else if ( txApduValue[i] >= 'a' && txApduValue[i] <= 'f' ) {
            txUCBuffer[j] = 0x10 * ((txApduValue[i] - 'a')+10);
        }

        
        if ( txApduValue[i+1] == ' ' ) { i+= 1; }
        if ( txApduValue[i+1] >= '0' && txApduValue[i+1] <= '9' ) {
            txUCBuffer[j] += (txApduValue[i+1] - '0');
        } else if ( txApduValue[i+1] >= 'A' && txApduValue[i+1] <= 'F' ) {
            txUCBuffer[j] += ((txApduValue[i+1] - 'A')+10);
        } else if ( txApduValue[i+1] >= 'a' && txApduValue[i+1] <= 'f' ) {
            txUCBuffer[j] += ((txApduValue[i+1] - 'a')+10);
        }

        j += 1;
    }
    
    if ( j < 5 ) {
        ShowError( SCARD_E_INVALID_VALUE );
        return 1;
    }

    rxLength = MAX_BUFFER_SIZE;
    rv = SCardTransmit( hCard, SCARD_PCI_T0, txUCBuffer, j, NULL,
                        rxUCBuffer, &rxLength );

    if ( rv != SCARD_S_SUCCESS ) {
        ShowError( rv );
        return 1;
    }
                        
    j = 0;

    for ( i=0; i < rxLength; i++ ) {
        if ( (rxUCBuffer[i]/0x10) >= 0x0A ) {
            rxApduValue[j++] = ((rxUCBuffer[i]/0x10)-10)+'A';
        } else {
            rxApduValue[j++] = (rxUCBuffer[i]/0x10) + '0';
        }

        if ( (rxUCBuffer[i]%0x10) >= 0x0A ) {
            rxApduValue[j++] = ((rxUCBuffer[i]%0x10)-10)+'A';
        } else {
            rxApduValue[j++] = (rxUCBuffer[i]%0x10) + '0';
        }

        rxApduValue[j++] = ' ';
    }
    
    rxApduValue[j++] = 0x00; /* NULL */


    rxNSApduValue = [NSString stringWithCString:rxApduValue]; 
    [rxTextField setStringValue:rxNSApduValue];
    
    rv = SCardDisconnect( hCard, SCARD_LEAVE_CARD );
    if ( rv != SCARD_S_SUCCESS ) {
        ShowError( rv );
        return 1;
    }

    SCardReleaseContext( hContext );
     
}

@end
