
/******************************************************************

	MUSCLE SmartCard Development ( http://www.linuxnet.com )
	    Title  : sys_generic.h
	    Package: pcsc lite
            Author : David Corcoran
            Date   : 11/8/99
	    License: Copyright (C) 1999 David Corcoran
	             <corcoran@linuxnet.com>
            Purpose: This handles abstract system level calls. 
	            
********************************************************************/

#ifndef __sys_generic_h__
#define __sys_generic_h__

#include <pcsclite.h>

#ifdef __cplusplus
extern "C" {
#endif     

  int SYS_Sleep( int );
  
  int SYS_USleep( int );
    
  int SYS_OpenFile( char*, int, int );

  int SYS_CloseFile( int );

  int SYS_RemoveFile( char* );

  int SYS_LockFile( int );
  
  int SYS_SeekFile( int, int );
  
  int SYS_ReadFile( int, char*, int );
  
  int SYS_WriteFile( int, char*, int );
  
  int SYS_GetPageSize( void );
  
  void *SYS_MemoryMap( int, int, int );
  
  int SYS_Fork();
  
  int SYS_Wait( int, int );
  
  int SYS_Stat( int );
  
  int SYS_Random( int, float, float );

  int SYS_Exit( int );

#ifdef __cplusplus
}
#endif     

#endif /* __sys_generic_h__ */
