/******************************************************************

            Title  : rpc_sechandler.c
            Package: PC/SC Lite
            Author : David Corcoran
            Date   : 05/16/00
	    License: Copyright (C) 2000 David Corcoran
	             <corcoran@linuxnet.com>
            Purpose: This handles security related services.

********************************************************************/

#include "winscard_rpc.h"
#include "rpc_sechandler.h"
#include <arpa/inet.h>
#include <debuglog.h>
#include <string.h>

LONG SECHVerifyHostValidity( SVCXPRT *in_addr ) {
  
  LONG rv;
  struct sockaddr_in *rem_addr;
  char *pcRemoteIP;

  /* Zero out everything */
  rv=0; rem_addr=0; pcRemoteIP=0;

  rem_addr   = svc_getcaller(in_addr);
  pcRemoteIP = strdup( inet_ntoa( rem_addr->sin_addr ) );
 
  /* Future releases will have a list of allow/deny 
     that will be checked for each incoming command  */

  /* Check if environment is only local */
  if ( strcmp( PCSCLITE_CLIENT_ENV, "LOCAL" ) == 0 ) {
    if ( strcmp( pcRemoteIP, "127.0.0.1" ) == 0 ) {
      rv = SCARD_S_SUCCESS;
    } else {
      DebugLogC("SECHVerifyHostValidity: Invalid request from ip: %s\n",
		pcRemoteIP, __FILE__, __LINE__ );
      rv = SCARD_E_INVALID_TARGET;
    }
  } else { /* Must be global or list defined */
    /* Check allow/deny list in /etc/pcsc.conf in future release */
    rv = SCARD_S_SUCCESS;
  }

  free(pcRemoteIP); pcRemoteIP = 0;
  return rv;
}


/* The other functions will come in future releases */
