/******************************************************************

            Title  : rpc_sechandler.h
            Package: PC/SC Lite
            Author : David Corcoran
            Date   : 05/16/00
	    License: Copyright (C) 2000 David Corcoran
	             <corcoran@linuxnet.com>
            Purpose: This handles security related services.
            LICENSE: See LICENSE

********************************************************************/

#ifndef __rpc_sechandler_h__
#define __rpc_sechandler_h__

#include <pcsclite.h>

#ifdef __cplusplus
extern "C" {
#endif 

#define SECH_MAXKEY_SIZE 16   /* 128 bit key size */

  typedef struct _SECHKeyBlob {
    UCHAR ucKey[SECH_MAXKEY_SIZE];
    DWORD dwKeyLength;
    DWORD dwAlgoType;
  } SECHKeyBlob, *PSECHKeyBlob;


  LONG SECHVerifyHostValidity( SVCXPRT* );
  
  LONG SECHEncryptAPDU( SECHKeyBlob psKey, PUCHAR pucPlain, DWORD dwPlainLen, 
			PUCHAR pucCrypt, LPDWORD pdwCryptLen );
  
  LONG SECHDecryptAPDU( SECHKeyBlob psKey, PUCHAR pucCrypt, DWORD dwCryptLen, 
			PUCHAR pucPlain, LPDWORD pdwPlainLen );
  
  LONG SECHCreateHash( PUCHAR pucAPDU, DWORD dwAPDULength, PUCHAR pucAPDUHsh,
		       LPDWORD pdwAPDULenHsh );
  
  LONG SECHVerifyHash( PUCHAR pucAPDU, DWORD dwAPDULength );
  

#ifdef __cplusplus
}
#endif 

#endif
