 
/******************************************************************

	MUSCLE SmartCard Development ( http://www.linuxnet.com )
	    Title  : winscard_rpc_adm.c
	    Package: pcsc lite
            Author : David Corcoran
            Date   : 07/18/00
	    License: Copyright (C) 2000 David Corcoran
	             <corcoran@linuxnet.com>
            Purpose: This handles smartcard reader additions/removals. 
	             over RPC.

********************************************************************/

#include <string.h>
#include "winscard_rpc.h"
#include "winscard_rpc_adm.h"

LONG SCardIntroduceReader( SCARDCONTEXT hContext, LPSTR szReaderName, 
			   DWORD dwChannelID, LPSTR szLibraryName ) {
  
  CLIENT *clnt;
  LONG liIndex;
  intro_struct  *result_1;
  intro_struct  scardintro_1_arg;   

  /* Zero out everything   */
  liIndex=0; clnt=0; result_1=0;
  memset( &scardintro_1_arg, 0x00, sizeof(intro_struct) );
  
  liIndex = SCardGetContext( hContext, 0 );

  if ( liIndex < 0 ) {
    return SCARD_E_INVALID_HANDLE;
  }

  scardintro_1_arg.hContext                    = hContext;
  scardintro_1_arg.dwChannelID                 = dwChannelID;
  scardintro_1_arg.szReaderName.RPC_LPSTR_val  = strdup(szReaderName);
  scardintro_1_arg.szReaderName.RPC_LPSTR_len  = strlen(szReaderName) + 1;
  scardintro_1_arg.szLibraryName.RPC_LPSTR_val = strdup(szLibraryName);
  scardintro_1_arg.szLibraryName.RPC_LPSTR_len = strlen(szLibraryName) + 1;

  clnt     = SCardGetClient( liIndex );
  result_1 = scardintroducereader_1(&scardintro_1_arg, clnt);  

  free(scardintro_1_arg.szReaderName.RPC_LPSTR_val);
  scardintro_1_arg.szReaderName.RPC_LPSTR_val = 0;  
  free(scardintro_1_arg.szLibraryName.RPC_LPSTR_val);
  scardintro_1_arg.szLibraryName.RPC_LPSTR_val = 0;  

  if ( result_1 == 0 ) {
    clnt_perror(clnt, "call failed:"); 
    return SCARD_F_COMM_ERROR;
  }

  return result_1->rv;
 }


LONG SCardForgetReader( SCARDCONTEXT hContext, LPSTR szReaderName ) {
  
  CLIENT *clnt;
  LONG liIndex;
  forget_struct  *result_1;
  forget_struct  scardforget_1_arg;   

  /* Zero out everything   */
  liIndex=0; clnt=0; result_1=0;
  memset( &scardforget_1_arg, 0x00, sizeof(forget_struct) );
  
  liIndex = SCardGetContext( hContext, 0 );

  if ( liIndex < 0 ) {
    return SCARD_E_INVALID_HANDLE;
  }

  scardforget_1_arg.hContext                = hContext;
  scardforget_1_arg.szReaderName.RPC_LPSTR_val = strdup(szReaderName);
  scardforget_1_arg.szReaderName.RPC_LPSTR_len = strlen(szReaderName) + 1;

  clnt     = SCardGetClient( liIndex );
  result_1 = scardforgetreader_1(&scardforget_1_arg, clnt);  

  free(scardforget_1_arg.szReaderName.RPC_LPSTR_val);
  scardforget_1_arg.szReaderName.RPC_LPSTR_val = 0;  

  if ( result_1 == 0 ) {
    clnt_perror(clnt, "call failed:"); 
    return SCARD_F_COMM_ERROR;
  }

  return result_1->rv;  
}
